class EventsController < ApplicationController

  def index
    @events = Event.all
    render json: @events
  end

  def show
    @event = Event.find(params[:id])
    render json: @event
  end

  def create
    @event = Event.new(event_params)
    if @event.save
      render json: @event, status: 201
    else
      render json: { errors: @event.errors.full_messages }, status: 422
    end
  end

  def errors
    @events = Event.all
    @errors = []
    @events.each do |event|
      if event.zacatek.nil?
        @errors << { error: 'Čas začátku akce není definován', event: event }
      elsif event.zacatek.year != Event.current_year
        @errors << { error: 'Čas začátku je v jiném roce', event: event }
      end
    end
    render json: @errors
  end

  private

    def event_params
      params.require(:event).permit(
        :nazev, :propozice, :kapacita,
        :zacatek, :zacatek_1_kola, :konec,
        :mistnost, :nazev_hry,
        :kriteria, :organizator,
        :startovne, :cena1, :cena2, :cena3, :dalsi_ceny
      )
    end

end
